# -*- coding: utf-8 -*-

import bytedtqs
from odps import options

# settings for the running process
conf = {
    'dc': 'va',  # the default dc setting =va/eu
    'update_live': False,  # default = False, FALSE/True for prelive/live environment
    'run_sql': True,  # default = True
    'start_date': '20250113',  # '20210101'
    'end_date': '20250119',
    'prefix': 'tmp_location_',
    'suffix': '20250206',  # datetime.now().strftime('%Y%m%d')
    'kms': "bytedance.ucenter.hash_hub",
    'version': 'v1.0.0.22 verified dkms',
    'lifecycle': 15,
    'long_lifecycle': 180,
    'decimal_place': 5,  # default = 5, only keep last 5 digital for lat/lng, 1.11 meter
    'SOH': '\u0001',
    'STX': '\u0002',
    'ETX': '\u0003',
    'project': 'tt_location',
    'project_pns': 'isolate_domain_tt_eng',
}

odps_conf = {
    'projects': [conf['project'], conf['project_pns'], 'user_dw', 'location', 'isolate_domain_pns', 'ecom',
                 'ecom_i18n'],
    'access_id': 'need apply from administrator',
    'access_key': 'need apply from administrator',
    'endpoint': "https://service.ap-southeast-1.maxcompute.aliyun.com/api",
}
# odps configuration: Siwei JIANG information
options.tunnel.use_instance_tunnel = True
options.tunnel.limit_instance_tunnel = True
options.tunnel.string_as_binary = True
# set the log view
options.verbose = True
# options.log_view_host = 'https://logview.alibaba-inc.com'
# PyODPS DataFrame 用 ODPS 执行时，参照下面 dataframe 相关配置，sort 时设置 limit 到一个比较大的值
options.df.odps.sort.limit = 100000000
options.connect_timeout = 86400
# 如果 Project 开启了 Isolation，下面的选项不是必需的
options.sql.settings = {'odps.sql.type.system.odps2': True}
options.sql.settings = {'odps.isolation.session.enable': True}
options.sql.settings = {'odps.sql.python.version': 'cp37'}
# speedup the query by restrict mapper/reducer/joiner settings
# options.sql.settings = {'odps.sql.udf.jvm.memory': 8192}
# options.sql.settings = {'odps.sql.udf.python.memory': 8192}

# tqs setting
tqs_conf = {
    'va': {
        'app_id': "8Kdtqd7NRHOrGH3wKzLvt3udXvU37qJNN0fFpbaO1cbAA4Rx",
        'app_key': "5Ieojqh9OSwDXHSnNMDG8d5VtSLt0wQLFc8YzwKsKXK6eeIM",
        'cluster': bytedtqs.Cluster.VA,
        'user_name': "siwei.jiang",
        'conf': {'yarn.cluster.name': "momet", 'mapreduce.job.queuename': "root.momet_tiktok_poi_process"},
        # 'conf': {'yarn.cluster.name': "vivid", 'mapreduce.job.queuename': "root.vivid_tiktok_poi_algo_cluster_2"},
        # 'conf': {'yarn.cluster.name': "fed01", 'mapreduce.job.queuename': "root.pns_closed_domin"},
    },
    'eu': {
        'app_id': "YJByIs8o78eaEyUjH1EGEVhCjAAXLlJFWnsNS1SQy4LO10WA",
        'app_key': "89G9I3LQ2qIqy1MdJcqvCCl3nBVw2V6pLmvRBjpRY6ea7snY",
        'cluster': bytedtqs.Cluster.EUTTP_ADHOC,
        'user_name': "siwei.jiang",
        'conf': {'yarn.cluster.name': "coati", 'mapreduce.job.queuename': "root.coati_location_ad_private"}
    }
}

# tos setting
tos_conf = {
    'ak': "30AP1AZY7E5ODRQJEFYD",
    'bucket_name': "siweijiang-us",
    'tos_psm': "toutiao.tos.tosapi",
    'tos_cluster': "default",
    'tos_idc': "maliva",
    'client_psm': "titok.location.kitex_demo"
}

# dataframe convert to data warehouse (ODPS, Dorado) 
df2dw_conf = {
    'int8': 'tinyint',  # 'tinyint',
    'int16': 'smallint',  # 'smallint',
    'int32': 'int',  # 'int',
    'int64': 'bigint',  # 'bigint',
    'float32': 'float',  # 'float',
    'float64': 'double',  # 'double',
    'list<string>': 'array<string>',
    'list<int8>': 'array<tinyint>',  # 'array<tinyint>',
    'list<int16>': 'array<smallint>',  # 'array<smallint>',
    'list<int32>': 'array<int>',  # 'array<int>',
    'list<int64>': 'array<bigint>',  # 'array<bigint>',
    'list<float32>': 'array<float>',  # 'array<float>',
    'list<float64>': 'array<double>',
    'list<bigint>': 'array<string>',
}

speedup = {
    'partition': '''set spark.sql.collapseGetJsonObject.enabled=true;
                    SET spark.hadoop.hive.exec.max.dynamic.partitions = 6000;
                    set spark.blacklist.enabled=true;           
                    set bytequery.sql.partition.predicate.check.enabled=false;''',
}
