# -*- coding: utf-8 -*-
import bytedtqs

from plbrdidge.core.config import conf
from plbrdidge.core.config import tqs_conf as tc
from plbrdidge.utils.logger import logger

TQS_DICT = {
    'WM_CONCAT': 'concat_ws',
}


class TqsUtils():
    def __init__(self, queue="va"):
        # 'va','va_conf,'eu
        self.queue = conf['dc'] if queue is None else queue
        v = tc[self.queue]
        self.client = bytedtqs.TQSClient(v['app_id'], v['app_key'], v['cluster'])
        self.user_name = v['user_name']
        self.config = v['conf']
        logger.info(f'tqs_conf:queue={self.queue},user_name={self.user_name},config={self.config}')

    def replace(self, sql_list):
        for k, v in TQS_DICT.items():
            ret = []
            for sql in sql_list:
                ret.append(sql.replace(k, v))
            sql_list = [str(r) for r in ret]
        return sql_list

    def execute_query(self, query):
        return self.client.execute_query(user_name=self.user_name, conf=self.config, query=query)

    def cancel_query(self, job_id):
        return self.client.cancel_query(job_id)
